Index: /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/CONFIG/AMM12/EXP00/namelist
===================================================================
--- /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/CONFIG/AMM12/EXP00/namelist	(revision 3582)
+++ /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/CONFIG/AMM12/EXP00/namelist	(revision 3583)
@@ -371,17 +371,20 @@
 &nam_tide      !   tide parameters (#ifdef key_tide)
 !-----------------------------------------------------------------------
-   ln_tide_pot   = .true.   !  use tidal potential forcing
-   nb_harmo      =    11    !  number of constituents used
-   clname(1)     =   'M2'   !  name of constituent
-   clname(2)     =   'S2'
-   clname(3)     =   'N2'
-   clname(4)     =   'K1'
-   clname(5)     =   'O1'
-   clname(6)     =   'Q1'
-   clname(7)     =   'M4'
-   clname(8)     =   'K2'
-   clname(9)     =   'P1'
-   clname(10)    =   'Mf'
-   clname(11)    =   'Mm'
+   ln_tide_pot   = .false.   !  use tidal potential forcing
+   clname(1)     =   'Q1'   !  name of constituent
+   clname(2)     =   'O1'
+   clname(3)     =   'P1'
+   clname(4)     =   'S1'
+   clname(5)     =   'K1'
+   clname(6)     =   '2N2'
+   clname(7)     =   'MU2'
+   clname(8)     =   'N2'
+   clname(9)     =   'NU2'
+   clname(10)    =   'M2'
+   clname(11)    =   'L2'
+   clname(12)    =   'T2'
+   clname(13)    =   'S2'
+   clname(14)    =   'K2'
+   clname(15)    =   'M4'
 /
 !-----------------------------------------------------------------------
@@ -427,35 +430,4 @@
 !-----------------------------------------------------------------------
    filtide      = 'bdydta/amm12_bdytide_'         !  file name root of tidal forcing files
-    tide_cpt(1)   ='Q1'  !  names of tidal components used
-    tide_cpt(2)   ='O1'  !  names of tidal components used
-    tide_cpt(3)   ='P1'  !  names of tidal components used
-    tide_cpt(4)   ='S1'  !  names of tidal components used
-    tide_cpt(5)   ='K1'  !  names of tidal components used
-    tide_cpt(6)   ='2N2' !  names of tidal components used
-    tide_cpt(7)   ='MU2' !  names of tidal components used
-    tide_cpt(8)   ='N2'  !  names of tidal components used
-    tide_cpt(9)   ='NU2' !  names of tidal components used
-    tide_cpt(10)   ='M2'  !  names of tidal components used
-    tide_cpt(11)   ='L2'  !  names of tidal components used
-    tide_cpt(12)   ='T2'  !  names of tidal components used
-    tide_cpt(13)   ='S2'  !  names of tidal components used
-    tide_cpt(14)   ='K2'  !  names of tidal components used
-    tide_cpt(15)   ='M4'  !  names of tidal components used
-    tide_speed(1)   = 13.398661 !  phase speeds of tidal components (deg/hour)
-    tide_speed(2)   = 13.943036 !  phase speeds of tidal components (deg/hour)
-    tide_speed(3)   = 14.958932 !  phase speeds of tidal components (deg/hour)
-    tide_speed(4)   = 15.000001 !  phase speeds of tidal components (deg/hour)
-    tide_speed(5)   = 15.041069 !  phase speeds of tidal components (deg/hour)
-    tide_speed(6)   = 27.895355 !  phase speeds of tidal components (deg/hour)
-    tide_speed(7)   = 27.968210 !  phase speeds of tidal components (deg/hour)
-    tide_speed(8)   = 28.439730 !  phase speeds of tidal components (deg/hour)
-    tide_speed(9)   = 28.512585 !  phase speeds of tidal components (deg/hour)
-    tide_speed(10)   = 28.984106 !  phase speeds of tidal components (deg/hour)
-    tide_speed(11)   = 29.528479 !  phase speeds of tidal components (deg/hour)
-    tide_speed(12)   = 29.958935 !  phase speeds of tidal components (deg/hour)
-    tide_speed(13)   = 30.000002 !  phase speeds of tidal components (deg/hour)
-    tide_speed(14)   = 30.082138 !  phase speeds of tidal components (deg/hour)
-    tide_speed(15)   = 57.968212 !  phase speeds of tidal components (deg/hour)
-    ln_tide_date = .true.               !  adjust tidal harmonics for start date of run
 /
 !!======================================================================
Index: /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90
===================================================================
--- /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 3582)
+++ /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 3583)
@@ -28,4 +28,5 @@
       INTEGER, POINTER, DIMENSION(:,:)   ::  nbmap
       REAL   , POINTER, DIMENSION(:,:)   ::  nbw
+      REAL   , POINTER, DIMENSION(:,:)   ::  nbd
       REAL   , POINTER, DIMENSION(:)     ::  flagu
       REAL   , POINTER, DIMENSION(:)     ::  flagv
@@ -73,4 +74,8 @@
    INTEGER, DIMENSION(jp_bdy) ::   nn_tra_dta      	    !: = 0 use the initial state as bdy dta ; 
                                                             !: = 1 read it in a NetCDF file
+   LOGICAL, DIMENSION(jp_bdy) ::   ln_tra_dmp               !: =T Tracer damping
+   LOGICAL, DIMENSION(jp_bdy) ::   ln_dyn3d_dmp             !: =T Baroclinic velocity damping
+   REAL,    DIMENSION(jp_bdy) ::   rn_time_dmp              !: Damping time scale in days
+
 #if defined key_lim2
    INTEGER, DIMENSION(jp_bdy) ::   nn_ice_lim2              ! Choice of boundary condition for sea ice variables 
@@ -101,5 +106,6 @@
    INTEGER,  DIMENSION(jp_bdy)                     ::   nn_dta            !: =0 => *all* data is set to initial conditions
                                                                           !: =1 => some data to be read in from data files
-   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::   dta_global        !: workspace for reading in global data arrays
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::   dta_global        !: workspace for reading in global data arrays (unstr.  bdy)
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::   dta_global2       !: workspace for reading in global data arrays (struct. bdy)
    TYPE(OBC_INDEX), DIMENSION(jp_bdy), TARGET      ::   idx_bdy           !: bdy indices (local process)
    TYPE(OBC_DATA) , DIMENSION(jp_bdy)              ::   dta_bdy           !: bdy external data (local process)
Index: /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 3582)
+++ /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 3583)
@@ -32,4 +32,5 @@
    USE ice_2
 #endif
+   USE sbcapr
 
    IMPLICIT NONE
@@ -108,9 +109,5 @@
 
             IF( nn_dyn2d(ib_bdy) .gt. 0 .and. nn_dyn2d_dta(ib_bdy) .eq. 0 ) THEN 
-               IF( nn_dyn2d(ib_bdy) .eq. jp_frs ) THEN
-                  ilen1(:) = nblen(:)
-               ELSE
-                  ilen1(:) = nblenrim(:)
-               ENDIF
+               ilen1(:) = nblen(:)
                igrd = 1
                DO ib = 1, ilen1(igrd)
@@ -134,9 +131,5 @@
 
             IF( nn_dyn3d(ib_bdy) .gt. 0 .and. nn_dyn3d_dta(ib_bdy) .eq. 0 ) THEN 
-               IF( nn_dyn3d(ib_bdy) .eq. jp_frs ) THEN
-                  ilen1(:) = nblen(:)
-               ELSE
-                  ilen1(:) = nblenrim(:)
-               ENDIF
+               ilen1(:) = nblen(:)
                igrd = 2 
                DO ib = 1, ilen1(igrd)
@@ -158,9 +151,5 @@
 
             IF( nn_tra(ib_bdy) .gt. 0 .and. nn_tra_dta(ib_bdy) .eq. 0 ) THEN 
-               IF( nn_tra(ib_bdy) .eq. jp_frs ) THEN
-                  ilen1(:) = nblen(:)
-               ELSE
-                  ilen1(:) = nblenrim(:)
-               ENDIF
+               ilen1(:) = nblen(:)
                igrd = 1                       ! Everything is at T-points here
                DO ib = 1, ilen1(igrd)
@@ -176,9 +165,5 @@
 #if defined key_lim2
             IF( nn_ice_lim2(ib_bdy) .gt. 0 .and. nn_ice_lim2_dta(ib_bdy) .eq. 0 ) THEN 
-               IF( nn_ice_lim2(ib_bdy) .eq. jp_frs ) THEN
-                  ilen1(:) = nblen(:)
-               ELSE
-                  ilen1(:) = nblenrim(:)
-               ENDIF
+               ilen1(:) = nblen(:)
                igrd = 1                       ! Everything is at T-points here
                DO ib = 1, ilen1(igrd)
@@ -207,5 +192,5 @@
             IF( PRESENT(jit) ) THEN
                ! Update barotropic boundary conditions only
-               ! jit is optional argument for fld_read and tide_update
+               ! jit is optional argument for fld_read and bdytide_update
                IF( nn_dyn2d(ib_bdy) .gt. 0 ) THEN
                   IF( nn_dyn2d_dta(ib_bdy) .eq. 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
@@ -214,71 +199,131 @@
                      dta_bdy(ib_bdy)%v2d(:) = 0.0
                   ENDIF
-                  IF( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) THEN ! update external data
-                     jend = jstart + 2
-                     CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), map=nbmap_ptr(jstart:jend),   &
-                     &              jit=jit, time_offset=time_offset )
-                  ENDIF
-                  IF( nn_dyn2d_dta(ib_bdy) .ge. 2 ) THEN ! update tidal harmonic forcing
-                     CALL tide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta_bdy(ib_bdy), td=tides(ib_bdy),   & 
-                     &                 jit=jit, time_offset=time_offset )
+                  IF (nn_tra(ib_bdy).ne.4) THEN
+                     IF (nn_dyn2d_dta(ib_bdy).eq.1.or.nn_dyn2d_dta(ib_bdy).eq.3.or.(ln_full_vel_array(ib_bdy).and.nn_dyn3d_dta(ib_bdy).eq.1)) THEN
+                        ! For the runoff case, no need to update the forcing (already done in the baroclinic part)
+                        jend = nb_bdy_fld(ib_bdy)
+                        IF ( nn_tra(ib_bdy) .GT. 0 .AND. nn_tra_dta(ib_bdy) .GE. 1 ) jend = jend - 2
+                        CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), map=nbmap_ptr(jstart:jend), jit=jit, time_offset=time_offset )
+                        IF ( nn_tra(ib_bdy) .GT. 0 .AND. nn_tra_dta(ib_bdy) .GE. 1 ) jend = jend + 2
+                        ! If full velocities in boundary data then split into barotropic and baroclinic data
+                        IF( ln_full_vel_array(ib_bdy) .and.                                             &
+                       &    ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 .or. nn_dyn3d_dta(ib_bdy) .eq. 1 ) ) THEN
+                           igrd = 2                      ! zonal velocity
+                           dta_bdy(ib_bdy)%u2d(:) = 0.0
+                           DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
+                              ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                              ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                              DO ik = 1, jpkm1
+                                 dta_bdy(ib_bdy)%u2d(ib) = dta_bdy(ib_bdy)%u2d(ib) &
+                       &                          + fse3u(ii,ij,ik) * umask(ii,ij,ik) * dta_bdy(ib_bdy)%u3d(ib,ik)
+                              END DO
+                              dta_bdy(ib_bdy)%u2d(ib) =  dta_bdy(ib_bdy)%u2d(ib) * hur(ii,ij)
+                              DO ik = 1, jpkm1
+                                 dta_bdy(ib_bdy)%u3d(ib,ik) = dta_bdy(ib_bdy)%u3d(ib,ik) - dta_bdy(ib_bdy)%u2d(ib)
+                              END DO
+                           END DO
+                           igrd = 3                      ! meridional velocity
+                           dta_bdy(ib_bdy)%v2d(:) = 0.0
+                           DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
+                              ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                              ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                              DO ik = 1, jpkm1
+                                 dta_bdy(ib_bdy)%v2d(ib) = dta_bdy(ib_bdy)%v2d(ib) &
+                       &                       + fse3v(ii,ij,ik) * vmask(ii,ij,ik) * dta_bdy(ib_bdy)%v3d(ib,ik)
+                              END DO
+                              dta_bdy(ib_bdy)%v2d(ib) =  dta_bdy(ib_bdy)%v2d(ib) * hvr(ii,ij)
+                              DO ik = 1, jpkm1
+                                 dta_bdy(ib_bdy)%v3d(ib,ik) = dta_bdy(ib_bdy)%v3d(ib,ik) - dta_bdy(ib_bdy)%v2d(ib)
+                              END DO
+                           END DO
+                        ENDIF                    
+                     ENDIF
+                     IF( nn_dyn2d_dta(ib_bdy) .ge. 2 ) THEN ! update tidal harmonic forcing
+                        CALL bdytide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta_bdy(ib_bdy), td=tides(ib_bdy),   & 
+                          &                 jit=jit, time_offset=time_offset )
+                     ENDIF
                   ENDIF
                ENDIF
             ELSE
-               IF( nn_dyn2d(ib_bdy) .gt. 0 .and. nn_dyn2d_dta(ib_bdy) .eq. 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
-                  dta_bdy(ib_bdy)%ssh(:) = 0.0
-                  dta_bdy(ib_bdy)%u2d(:) = 0.0
-                  dta_bdy(ib_bdy)%v2d(:) = 0.0
+               IF (nn_tra(ib_bdy).eq.4) then      ! runoff condition
+                  jend = nb_bdy_fld(ib_bdy)
+                  CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), map=nbmap_ptr(jstart:jend), time_offset=time_offset )
+                  !
+                  igrd = 2                      ! zonal velocity
+                  DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
+                     ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                     ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     dta_bdy(ib_bdy)%u2d(ib) = dta_bdy(ib_bdy)%u2d(ib) / ( e2u(ii,ij) * hu_0(ii,ij) )
+                  END DO
+                  !
+                  igrd = 3                      ! meridional velocity
+                  DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
+                     ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                     ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     dta_bdy(ib_bdy)%v2d(ib) = dta_bdy(ib_bdy)%v2d(ib) / ( e1v(ii,ij) * hv_0(ii,ij) )
+                  END DO
+               ELSE
+                  IF( nn_dyn2d(ib_bdy) .gt. 0 .and. nn_dyn2d_dta(ib_bdy) .eq. 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
+                     dta_bdy(ib_bdy)%ssh(:) = 0.0
+                     dta_bdy(ib_bdy)%u2d(:) = 0.0
+                     dta_bdy(ib_bdy)%v2d(:) = 0.0
+                  ENDIF
+                  IF( nb_bdy_fld(ib_bdy) .gt. 0 ) THEN ! update external data
+                     jend = nb_bdy_fld(ib_bdy)
+                     CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), map=nbmap_ptr(jstart:jend), time_offset=time_offset )
+                  ENDIF
+                  ! If full velocities in boundary data then split into barotropic and baroclinic data
+                  IF( ln_full_vel_array(ib_bdy) .and.                                             &
+                 &    ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 .or. nn_dyn3d_dta(ib_bdy) .eq. 1 ) ) THEN
+                     igrd = 2                      ! zonal velocity
+                     dta_bdy(ib_bdy)%u2d(:) = 0.0
+                     DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
+                        ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                        ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                        DO ik = 1, jpkm1
+                           dta_bdy(ib_bdy)%u2d(ib) = dta_bdy(ib_bdy)%u2d(ib) &
+                 &                       + fse3u(ii,ij,ik) * umask(ii,ij,ik) * dta_bdy(ib_bdy)%u3d(ib,ik)
+                        END DO
+                        dta_bdy(ib_bdy)%u2d(ib) =  dta_bdy(ib_bdy)%u2d(ib) * hur(ii,ij)
+                        DO ik = 1, jpkm1
+                           dta_bdy(ib_bdy)%u3d(ib,ik) = dta_bdy(ib_bdy)%u3d(ib,ik) - dta_bdy(ib_bdy)%u2d(ib)
+                        END DO
+                     END DO
+                     igrd = 3                      ! meridional velocity
+                     dta_bdy(ib_bdy)%v2d(:) = 0.0
+                     DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
+                        ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                        ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                        DO ik = 1, jpkm1
+                           dta_bdy(ib_bdy)%v2d(ib) = dta_bdy(ib_bdy)%v2d(ib) &
+                 &                       + fse3v(ii,ij,ik) * vmask(ii,ij,ik) * dta_bdy(ib_bdy)%v3d(ib,ik)
+                        END DO
+                        dta_bdy(ib_bdy)%v2d(ib) =  dta_bdy(ib_bdy)%v2d(ib) * hvr(ii,ij)
+                        DO ik = 1, jpkm1
+                           dta_bdy(ib_bdy)%v3d(ib,ik) = dta_bdy(ib_bdy)%v3d(ib,ik) - dta_bdy(ib_bdy)%v2d(ib)
+                        END DO
+                     END DO
+                  ENDIF
+                  IF( nn_dyn2d(ib_bdy) .gt. 0 .and. nn_dyn2d_dta(ib_bdy) .ge. 2 ) THEN ! update tidal harmonic forcing
+                     CALL bdytide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta_bdy(ib_bdy), td=tides(ib_bdy), time_offset=time_offset )
+                  ENDIF
                ENDIF
-               IF( nb_bdy_fld(ib_bdy) .gt. 0 ) THEN ! update external data
-                  jend = jstart + nb_bdy_fld(ib_bdy) - 1
-                  CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), map=nbmap_ptr(jstart:jend), time_offset=time_offset )
-               ENDIF
-               IF( nn_dyn2d(ib_bdy) .gt. 0 .and. nn_dyn2d_dta(ib_bdy) .ge. 2 ) THEN ! update tidal harmonic forcing
-                  CALL tide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta_bdy(ib_bdy), td=tides(ib_bdy), time_offset=time_offset )
-               ENDIF
             ENDIF
             jstart = jend+1
-
-            ! If full velocities in boundary data then split into barotropic and baroclinic data
-            ! (Note that we have already made sure that you can't use ln_full_vel = .true. at the same
-            ! time as the dynspg_ts option). 
-
-            IF( ln_full_vel_array(ib_bdy) .and.                                             & 
-           &    ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 .or. nn_dyn3d_dta(ib_bdy) .eq. 1 ) ) THEN 
-
-               igrd = 2                      ! zonal velocity
-               dta_bdy(ib_bdy)%u2d(:) = 0.0
-               DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
+         END IF ! nn_dta(ib_bdy) = 1
+      END DO  ! ib_bdy
+
+      IF ( ln_apr_obc ) THEN
+         DO ib_bdy = 1, nb_bdy
+            IF (nn_tra(ib_bdy).NE.4)THEN
+               igrd = 1                      ! meridional velocity
+               DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)
                   ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
                   ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                  DO ik = 1, jpkm1
-                     dta_bdy(ib_bdy)%u2d(ib) = dta_bdy(ib_bdy)%u2d(ib) &
-              &                                + fse3u(ii,ij,ik) * umask(ii,ij,ik) * dta_bdy(ib_bdy)%u3d(ib,ik)
-                  END DO
-                  dta_bdy(ib_bdy)%u2d(ib) =  dta_bdy(ib_bdy)%u2d(ib) * hur(ii,ij)
-                  DO ik = 1, jpkm1
-                     dta_bdy(ib_bdy)%u3d(ib,ik) = dta_bdy(ib_bdy)%u3d(ib,ik) - dta_bdy(ib_bdy)%u2d(ib) 
-                  END DO
-               END DO
-
-               igrd = 3                      ! meridional velocity
-               dta_bdy(ib_bdy)%v2d(:) = 0.0
-               DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
-                  ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                  ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                  DO ik = 1, jpkm1
-                     dta_bdy(ib_bdy)%v2d(ib) = dta_bdy(ib_bdy)%v2d(ib) &
-              &                                + fse3v(ii,ij,ik) * vmask(ii,ij,ik) * dta_bdy(ib_bdy)%v3d(ib,ik)
-                  END DO
-                  dta_bdy(ib_bdy)%v2d(ib) =  dta_bdy(ib_bdy)%v2d(ib) * hvr(ii,ij)
-                  DO ik = 1, jpkm1
-                     dta_bdy(ib_bdy)%v3d(ib,ik) = dta_bdy(ib_bdy)%v3d(ib,ik) - dta_bdy(ib_bdy)%v2d(ib) 
-                  END DO
-               END DO
-    
-            ENDIF
-
-         END IF ! nn_dta(ib_bdy) = 1
-      END DO  ! ib_bdy
+                  dta_bdy(ib_bdy)%ssh(ib) = dta_bdy(ib_bdy)%ssh(ib) + ssh_ib(ii,ij)
+               ENDDO
+            ENDIF
+         ENDDO
+      ENDIF
 
       IF( nn_timing == 1 ) CALL timing_stop('bdy_dta')
@@ -326,4 +371,9 @@
       IF( nn_timing == 1 ) CALL timing_start('bdy_dta_init')
 
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) 'bdy_dta_ini : initialization of data at the open boundaries'
+      IF(lwp) WRITE(numout,*) '~~~~~~~~~~'
+      IF(lwp) WRITE(numout,*) ''
+
       ! Set nn_dta
       DO ib_bdy = 1, nb_bdy
@@ -357,4 +407,5 @@
          ENDIF
 #endif               
+         IF(lwp) WRITE(numout,*) 'Maximum number of files to open =',nb_bdy_fld(ib_bdy)
       ENDDO            
 
@@ -408,9 +459,4 @@
             ln_full_vel_array(ib_bdy) = ln_full_vel
 
-            IF( ln_full_vel_array(ib_bdy) .and. lk_dynspg_ts )  THEN
-               CALL ctl_stop( 'bdy_dta_init: ERROR, cannot specify full velocities in boundary data',&
-            &                  'with dynspg_ts option' )   ;   RETURN  
-            ENDIF             
-
             nblen => idx_bdy(ib_bdy)%nblen
             nblenrim => idx_bdy(ib_bdy)%nblenrim
@@ -420,24 +466,19 @@
             IF( nn_dyn2d(ib_bdy) .gt. 0 .and. ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) ) THEN 
 
-               IF( nn_dyn2d(ib_bdy) .ne. jp_frs ) THEN
+               IF( nn_tra(ib_bdy) .ne. 4 ) THEN ! runoff condition : no ssh reading
                   jfld = jfld + 1
                   blf_i(jfld) = bn_ssh
                   ibdy(jfld) = ib_bdy
                   igrid(jfld) = 1
-                  ilen1(jfld) = nblenrim(igrid(jfld))
+                  ilen1(jfld) = nblen(igrid(jfld))
                   ilen3(jfld) = 1
                ENDIF
 
                IF( .not. ln_full_vel_array(ib_bdy) ) THEN
-
                   jfld = jfld + 1
                   blf_i(jfld) = bn_u2d
                   ibdy(jfld) = ib_bdy
                   igrid(jfld) = 2
-                  IF( nn_dyn2d(ib_bdy) .eq. jp_frs ) THEN
-                     ilen1(jfld) = nblen(igrid(jfld))
-                  ELSE
-                     ilen1(jfld) = nblenrim(igrid(jfld))
-                  ENDIF
+                  ilen1(jfld) = nblen(igrid(jfld))
                   ilen3(jfld) = 1
 
@@ -446,11 +487,6 @@
                   ibdy(jfld) = ib_bdy
                   igrid(jfld) = 3
-                  IF( nn_dyn2d(ib_bdy) .eq. jp_frs ) THEN
-                     ilen1(jfld) = nblen(igrid(jfld))
-                  ELSE
-                     ilen1(jfld) = nblenrim(igrid(jfld))
-                  ENDIF
+                  ilen1(jfld) = nblen(igrid(jfld))
                   ilen3(jfld) = 1
-
                ENDIF
 
@@ -466,9 +502,5 @@
                ibdy(jfld) = ib_bdy
                igrid(jfld) = 2
-               IF( nn_dyn3d(ib_bdy) .eq. jp_frs ) THEN
-                  ilen1(jfld) = nblen(igrid(jfld))
-               ELSE
-                  ilen1(jfld) = nblenrim(igrid(jfld))
-               ENDIF
+               ilen1(jfld) = nblen(igrid(jfld))
                ilen3(jfld) = jpk
 
@@ -477,9 +509,5 @@
                ibdy(jfld) = ib_bdy
                igrid(jfld) = 3
-               IF( nn_dyn3d(ib_bdy) .eq. jp_frs ) THEN
-                  ilen1(jfld) = nblen(igrid(jfld))
-               ELSE
-                  ilen1(jfld) = nblenrim(igrid(jfld))
-               ENDIF
+               ilen1(jfld) = nblen(igrid(jfld))
                ilen3(jfld) = jpk
 
@@ -493,9 +521,5 @@
                ibdy(jfld) = ib_bdy
                igrid(jfld) = 1
-               IF( nn_tra(ib_bdy) .eq. jp_frs ) THEN
-                  ilen1(jfld) = nblen(igrid(jfld))
-               ELSE
-                  ilen1(jfld) = nblenrim(igrid(jfld))
-               ENDIF
+               ilen1(jfld) = nblen(igrid(jfld))
                ilen3(jfld) = jpk
 
@@ -504,9 +528,5 @@
                ibdy(jfld) = ib_bdy
                igrid(jfld) = 1
-               IF( nn_tra(ib_bdy) .eq. jp_frs ) THEN
-                  ilen1(jfld) = nblen(igrid(jfld))
-               ELSE
-                  ilen1(jfld) = nblenrim(igrid(jfld))
-               ENDIF
+               ilen1(jfld) = nblen(igrid(jfld))
                ilen3(jfld) = jpk
 
@@ -521,9 +541,5 @@
                ibdy(jfld) = ib_bdy
                igrid(jfld) = 1
-               IF( nn_ice_lim2(ib_bdy) .eq. jp_frs ) THEN
-                  ilen1(jfld) = nblen(igrid(jfld))
-               ELSE
-                  ilen1(jfld) = nblenrim(igrid(jfld))
-               ENDIF
+               ilen1(jfld) = nblen(igrid(jfld))
                ilen3(jfld) = 1
 
@@ -532,9 +548,5 @@
                ibdy(jfld) = ib_bdy
                igrid(jfld) = 1
-               IF( nn_ice_lim2(ib_bdy) .eq. jp_frs ) THEN
-                  ilen1(jfld) = nblen(igrid(jfld))
-               ELSE
-                  ilen1(jfld) = nblenrim(igrid(jfld))
-               ENDIF
+               ilen1(jfld) = nblen(igrid(jfld))
                ilen3(jfld) = 1
 
@@ -543,9 +555,5 @@
                ibdy(jfld) = ib_bdy
                igrid(jfld) = 1
-               IF( nn_ice_lim2(ib_bdy) .eq. jp_frs ) THEN
-                  ilen1(jfld) = nblen(igrid(jfld))
-               ELSE
-                  ilen1(jfld) = nblenrim(igrid(jfld))
-               ENDIF
+               ilen1(jfld) = nblen(igrid(jfld))
                ilen3(jfld) = 1
 
@@ -566,5 +574,4 @@
       ENDDO ! ib_bdy
 
-
       DO jfld = 1, nb_bdy_fld_sum
          ALLOCATE( bf(jfld)%fnow(ilen1(jfld),1,ilen3(jfld)) )
@@ -577,5 +584,5 @@
       jstart = 1
       DO ib_bdy = 1, nb_bdy
-         jend = jstart + nb_bdy_fld(ib_bdy) - 1
+         jend = nb_bdy_fld(ib_bdy) 
          CALL fld_fill( bf(jstart:jend), blf_i(jstart:jend), cn_dir_array(ib_bdy), 'bdy_dta',   &
          &              'open boundary conditions', 'nambdy_dta' )
@@ -596,12 +603,13 @@
          IF (nn_dyn2d(ib_bdy) .gt. 0) THEN
             IF( nn_dyn2d_dta(ib_bdy) .eq. 0 .or. nn_dyn2d_dta(ib_bdy) .eq. 2 .or. ln_full_vel_array(ib_bdy) ) THEN
-               IF( nn_dyn2d(ib_bdy) .eq. jp_frs ) THEN
-                  ilen0(1:3) = nblen(1:3)
-               ELSE
-                  ilen0(1:3) = nblenrim(1:3)
-               ENDIF
-               ALLOCATE( dta_bdy(ib_bdy)%ssh(ilen0(1)) )
+               ilen0(1:3) = nblen(1:3)
                ALLOCATE( dta_bdy(ib_bdy)%u2d(ilen0(2)) )
                ALLOCATE( dta_bdy(ib_bdy)%v2d(ilen0(3)) )
+               IF (nn_dyn2d_dta(ib_bdy).eq.1.or.nn_dyn2d_dta(ib_bdy).eq.3) THEN
+                  jfld = jfld + 1
+                  dta_bdy(ib_bdy)%ssh => bf(jfld)%fnow(:,1,1)
+               ELSE
+                  ALLOCATE( dta_bdy(ib_bdy)%ssh(nblen(1)) )
+               ENDIF
             ELSE
                IF( nn_dyn2d(ib_bdy) .ne. jp_frs ) THEN
@@ -617,9 +625,5 @@
 
          IF ( nn_dyn3d(ib_bdy) .gt. 0 .and. nn_dyn3d_dta(ib_bdy) .eq. 0 ) THEN
-            IF( nn_dyn3d(ib_bdy) .eq. jp_frs ) THEN
-               ilen0(1:3) = nblen(1:3)
-            ELSE
-               ilen0(1:3) = nblenrim(1:3)
-            ENDIF
+            ilen0(1:3) = nblen(1:3)
             ALLOCATE( dta_bdy(ib_bdy)%u3d(ilen0(2),jpk) )
             ALLOCATE( dta_bdy(ib_bdy)%v3d(ilen0(3),jpk) )
@@ -636,9 +640,5 @@
          IF (nn_tra(ib_bdy) .gt. 0) THEN
             IF( nn_tra_dta(ib_bdy) .eq. 0 ) THEN
-               IF( nn_tra(ib_bdy) .eq. jp_frs ) THEN
-                  ilen0(1:3) = nblen(1:3)
-               ELSE
-                  ilen0(1:3) = nblenrim(1:3)
-               ENDIF
+               ilen0(1:3) = nblen(1:3)
                ALLOCATE( dta_bdy(ib_bdy)%tem(ilen0(1),jpk) )
                ALLOCATE( dta_bdy(ib_bdy)%sal(ilen0(1),jpk) )
@@ -654,9 +654,5 @@
          IF (nn_ice_lim2(ib_bdy) .gt. 0) THEN
             IF( nn_ice_lim2_dta(ib_bdy) .eq. 0 ) THEN
-               IF( nn_ice_lim2(ib_bdy) .eq. jp_frs ) THEN
-                  ilen0(1:3) = nblen(1:3)
-               ELSE
-                  ilen0(1:3) = nblenrim(1:3)
-               ENDIF
+               ilen0(1:3) = nblen(1:3)
                ALLOCATE( dta_bdy(ib_bdy)%frld(ilen0(1)) )
                ALLOCATE( dta_bdy(ib_bdy)%hicif(ilen0(1)) )
